/*
 * Created on Oct 28, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package net.sf.sageplugins.webserver;

import java.io.File;
import java.io.PrintWriter;
import java.text.DateFormat;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.servlet.http.HttpServletRequest;

import net.sf.sageplugins.sageutils.Translate;

/**
 * @author Owner
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class Airing {
	static final public int ID_TYPE_MEDIAFILE = 0;

	static final public int ID_TYPE_AIRING = 1;

	Object sageAiring;

	int idType;

	int id;

	Airing(HttpServletRequest req) throws Exception {
		idType = -1;
		id = -1;
		sageAiring = null;

		String idStr = req.getParameter("MediaFileId");
		if (idStr != null && !idStr.equals(""))
			idType = Airing.ID_TYPE_MEDIAFILE;
		else {
			idStr = req.getParameter("AiringId");
			if (idStr != null && !idStr.equals(""))
				idType = Airing.ID_TYPE_AIRING;
		}
		if (idStr != null) {
			try {
				id = Integer.parseInt(idStr);
				if (idType == ID_TYPE_MEDIAFILE) {
					sageAiring = SageApi.Api("GetMediaFileForID",
							new Object[] { new Integer(id) });
				} else if (idType == ID_TYPE_AIRING) {
					sageAiring = SageApi.Api("GetAiringForID",
							new Object[] { new Integer(id) });
				}
			} catch (NumberFormatException e) {
				id = -1;
			}
		}
		if (sageAiring == null) {
			throw new Exception("airing Id not found");
		}
		if (idType == ID_TYPE_AIRING) {
			Object mf = SageApi.Api("GetMediaFileForAiring",
					new Object[] { sageAiring });
			if (mf != null) {
				sageAiring = mf;
				id = SageApi.IntApi("GetMediaFileID", new Object[] { mf });
				idType = ID_TYPE_MEDIAFILE;
			}
		}
	}

	Airing(String epgid) throws Exception {
		this.idType = ID_TYPE_AIRING;

	}

	Airing(int idType, int id) throws Exception {
		this.idType = idType;
		this.id = id;
		if (idType == ID_TYPE_MEDIAFILE) {
			sageAiring = SageApi.Api("GetMediaFileForID",
					new Object[] { new Integer(id) });
		} else if (idType == ID_TYPE_AIRING) {
			sageAiring = SageApi.Api("GetAiringForID",
					new Object[] { new Integer(id) });
		} else {
			throw new NumberFormatException("invalid idType");
		}
		if (sageAiring == null) {
			throw new Exception("airing Id not found");
		}
		if (idType == ID_TYPE_AIRING) {
			Object mf = SageApi.Api("GetMediaFileForAiring",
					new Object[] { sageAiring });
			if (mf != null) {
				sageAiring = mf;
				idType = ID_TYPE_MEDIAFILE;
				id = SageApi.IntApi("GetMediaFileID", new Object[] { mf });
			}
		}
	}

	public Airing(Object sageAiring) throws Exception {
		this.sageAiring = sageAiring;
		if (SageApi
				.booleanApi("IsMediaFileObject", new Object[] { sageAiring }))
			idType = ID_TYPE_MEDIAFILE;
		else if (SageApi.booleanApi("IsAiringObject",
				new Object[] { sageAiring }))
			idType = ID_TYPE_AIRING;
		else
			throw new NumberFormatException("invalid Object");

		if (idType == ID_TYPE_MEDIAFILE)
			this.id = SageApi.IntApi("GetMediaFileID",
					new Object[] { sageAiring });
		else if (idType == ID_TYPE_AIRING)
			this.id = SageApi
					.IntApi("GetAiringID", new Object[] { sageAiring });
		else
			throw new NumberFormatException("invalid idType");
		if (idType == ID_TYPE_AIRING) {
			Object mf = SageApi.Api("GetMediaFileForAiring",
					new Object[] { sageAiring });
			if (mf != null) {
				sageAiring = mf;
				idType = ID_TYPE_MEDIAFILE;
				id = SageApi.IntApi("GetMediaFileID", new Object[] { mf });
			}
		}
	}

	public boolean getWatched() throws Exception {
		return SageApi.booleanApi("IsWatched", new Object[] { sageAiring });
	}

	public String getTitle() throws Exception {
		String title = SageApi.StringApi("GetAiringTitle",
				new Object[] { sageAiring });
		if (title == null || title.equals(""))
			return "Unknown airing";
		return title;
	}

	public String getEpisode() throws Exception {
		return SageApi.StringApi("GetShowEpisode", new Object[] { sageAiring });
	}

	public String getDescription() throws Exception {
		String s = SageApi.StringApi("GetShowDescription", new Object[] { sageAiring });
		if (s != null && s.length() > 0) {
			s = Translate.encode(s);
			s = s.replaceAll("\r\n", "\n");
			s = s.replaceAll("\n\n+", "\n\n");
			s = s.trim().replaceAll("[\r\n]", "<br/>\r\n");
		}
		if (s == null) s = "";
		return s;
	}

	public Date getStartDate() throws Exception {
		return new Date(((Long) SageApi.Api("GetAiringStartTime",
				new Object[] { sageAiring })).longValue());
	}

	public long getStartMillis() throws Exception {
		return ((Long) SageApi.Api("GetAiringStartTime",
				new Object[] { sageAiring })).longValue();
	}

	public Date getEndDate() throws Exception {
		return new Date(((Long) SageApi.Api("GetAiringEndTime",
				new Object[] { sageAiring })).longValue());
	}

	public long getEndMillis() throws Exception {
		return ((Long) SageApi.Api("GetAiringEndTime",
				new Object[] { sageAiring })).longValue();
	}

	public long getDuration() throws Exception {
		return (((Long) SageApi.Api("GetAiringDuration",
				new Object[] { sageAiring })).longValue());
	}
	public String getSize() throws Exception {
		Long size = (Long) SageApi.Api("GetSize", new Object[] { sageAiring });
		if (size != null) {
			DecimalFormat fmt = new DecimalFormat("0.00");
			return (fmt.format(size.doubleValue() / 1000000000) + "Gb");
		}
		return "";
	}
	public String getChannelNum() throws Exception {
		return SageApi.StringApi("GetChannelNumber",
				new Object[] { sageAiring });
	}

	public String getChannelName() throws Exception {
		return SageApi.StringApi("GetChannelName", new Object[] { sageAiring });
	}

	public String getChannel() throws Exception {
		return getChannelNum() + "-" + getChannelName();
	}
	
	public Boolean getFirstRun() throws Exception {
		return SageApi.booleanApi("IsShowFirstRun", new Object[] { sageAiring });
	}

	public Boolean getManual() throws Exception {
		return SageApi.booleanApi("IsManualRecord", new Object[] { sageAiring });
	}

	public Boolean getFavorite() throws Exception {
		return SageApi.booleanApi("IsFavorite", new Object[] { sageAiring });
	}

	public Boolean getCurRecording() throws Exception {
		return SageApi.booleanApi("IsFileCurrentlyRecording", new Object[] { sageAiring });
	}


	public String getCategory() throws Exception {
		return SageApi.StringApi("GetShowCategory", new Object[] { sageAiring });
	}

	public String getSubCategory() throws Exception {
		return SageApi.StringApi("GetShowSubCategory", new Object[] { sageAiring });
	}
		
	public String getAiringShortDescr() throws Exception {
		return SageApi.StringApi("PrintAiringShort", new Object[] { this.sageAiring });
	}

	public void printAiringTableCell(HttpServletRequest req, PrintWriter out,
			boolean hascheckbox, boolean usechannellogos, Object RecSchedList)
			throws Exception {
		String tdclass = "";
		if (getWatched()) {
			tdclass = "watched";
		}
		out.println("   <table width=\"100%\" class=\"epgcell\"><tr>");
		out.println("   <td class=\"" + getBorderClassName() + "\">");
		out.println("   <table width=\" 100%\"class=\"" + getBgClassName(false)
				+ "\"><tr>");
		if (hascheckbox) {
			out
					.print("      <td class='checkbox'><input type='checkbox' name=\"");
			if (idType == ID_TYPE_AIRING)
				out.print("AiringId");
			if (idType == ID_TYPE_MEDIAFILE)
				out.print("MediaFileId");
			out.println("\" value=\"" + Integer.toString(id) + "\"/></td>");
		}
		out.println("      <td class=\"" + tdclass + "\">");
		out.println("<div class=\"crop" + tdclass + "\">");
		// note -- no spaces between <img and titletext to prevent word-wrapping
		if (idType == ID_TYPE_AIRING)
			out.print("<a href=\"DetailedInfo?AiringId=" + Integer.toString(id)
					+ "\">");
		if (idType == ID_TYPE_MEDIAFILE)
			out.print("<a href=\"DetailedInfo?MediaFileId="
					+ Integer.toString(id) + "\">");
		if (RecSchedList != null
				&& 1 == SageApi.Size(SageApi.Api("DataIntersection",
						new Object[] { RecSchedList, this.sageAiring }))) {
			out
					.print("<img src=\"recording.gif\" class=\"RecordingIndicator\"/>");
		}
		String title = getTitle();

		if (idType == ID_TYPE_MEDIAFILE) {
			if (SageApi.booleanApi("IsMusicFile", new Object[] { sageAiring })) {
				title = "Album: " + title;
				String s = (String) SageApi.Api("GetPeopleInShow", sageAiring);
				if (s != null && s.length() > 0) {
					title = title + " by: " + s;
				}
			} else if (SageApi.booleanApi("IsPictureFile",
					new Object[] { sageAiring })) {
				title = "Picture: " + title;
			}
		}
		out.println(Translate.encode(title));

		String ep = getEpisode();
		if (ep != null && !ep.equals("")) {
			out.println("         <br/>" + Translate.encode(ep));
		}
		out.println("      </a></div></td>");
		Date date = getStartDate();
		SimpleDateFormat df = new SimpleDateFormat("EEE, MMM d");
		DateFormat dtf = DateFormat.getTimeInstance(DateFormat.SHORT);
		out.println("      <td class=\"datecell\"><div class=\"crop" + tdclass
				+ "\">" + df.format(date) + "<br/>" + dtf.format(date));
		date = getEndDate();
		out
				.println("&nbsp;-&nbsp;" + dtf.format(date) + "\r\n"
						+ "</div></td>");
		out.println("      <td class=\"channelcell\"><div class=\"crop"
				+ tdclass + "\">" + Translate.encode(getChannelNum()) + " - ");
		Object channel = SageApi.Api("GetChannel", sageAiring);
		if (usechannellogos && null != SageApi.Api("GetChannelLogo", channel)) {
			String chID = SageApi.Api("GetStationID", new Object[] { channel })
					.toString();
			out
					.println("<img class=\"infochannellogo\" src=\"ChannelLogo?ChannelID="
							+ chID
							+ "\" alt=\""
							+ Translate.encode(getChannelName())
							+ " logo\" title=\""
							+ Translate.encode(getChannelName()) + "\"/>");
		} else {
			out.println(Translate.encode(getChannelName()));
		}
		out.println("      </div></td>");
		out.println("   </tr></table></td></tr></table>");
	}

	public void printAiringXML(HttpServletRequest req, PrintWriter out)
			throws Exception {
/*		<StartDate>Jul 6, 2005</StartDate>
		<StartTime>10:00:00 PM</StartTime>
		<EndTime>11:00:00 PM</EndTime>
		<Duration>0 min</Duration>
		<File>\\Tuckman-Server\MyTV\CSINY-AmericanDreamers-5355854-0.mpg</File>
		<FirstRun>false</FirstRun>
		<Favorite>false</Favorite>
		<Manual>true</Manual>
		<Category>Crime drama</Category>
		<SubCategory>Action</SubCategory>
		<ExternalID>EP6797140004</ExternalID>
		<ChannelNumber>6</ChannelNumber>
		<ChannelName>WTEV</ChannelName>*/
		String s;
		out.println("<Airing>");
		out.println("\t<Title>" + Translate.encode(getTitle()) + "</Title>");
		out.println("\t<Episode>" + Translate.encode(getEpisode()) + "</Episode>");
		out.println("\t<Description>" + Translate.encode(getDescription()) + "</Description>");
		out.println("\t<ChannelNumber>" + getChannelNum() + "</ChannelNumber>");
		out.println("\t<ChannelName>" + getChannelName() + "</ChannelName>");
		out.println("\t<FirstRun>" + getFirstRun() + "</FirstRun>");
		out.println("\t<Favorite>" + getFavorite() + "</Favorite>");
		out.println("\t<Manual>" + getManual() + "</Manual>");
		out.println("\t<Category>" + getCategory() + "</Category>");
		out.println("\t<SubCategory>" + getSubCategory() + "</SubCategory>");
		out.println("\t<Watched>" + getWatched() + "</Watched>");
		out.println("\t<Size>" + getSize() + "</Size>");
		out.println("\t<Start>" + getStartDate() + "</Start>");
		out.println("\t<End>" + getEndDate() + "</End>");
		long duration=getDuration();
		if ( duration>3600000){
			long mins=getDuration()/60000;
			s = mins/60+"h "+mins%60+"m";
		} else 
			s = getDuration()/60000+" m";
		out.println("\t<Duration>" + s + "</Duration>");
		File files[]=(File[])SageApi.Api("GetSegmentFiles",new Object[]{sageAiring});
		s = "";
		if ( files!=null ){
			for ( int i=0;i<files.length;i++) {
				s = Translate.encode(files[i].getAbsolutePath());
				out.println("\t<File>" + s + "</File>");
			}
		}
		out.println("\t<Recording>" + getCurRecording() + "</Recording>");
		out.println("\t<ID>" + Integer.toString(id) + "</ID>");
		out.println("</Airing>\n");
	}

	public String getBorderClassName() throws Exception {
		if (SageApi.booleanApi("IsFileCurrentlyRecording",
				new Object[] { sageAiring }))
			return "showrecording";
		if (SageApi.booleanApi("IsManualRecord", new Object[] { sageAiring }))
			return "showmanrec";
		if (SageApi.booleanApi("IsDontLike", new Object[] { sageAiring }))
			return "showdontlike";
		if (SageApi.booleanApi("IsFavorite", new Object[] { sageAiring }))
			return "showfavorite";
		return "";
	}

	public String getBgClassName(boolean includeOld) throws Exception {
		String BgClassName;
		if (includeOld && this.getEndMillis() < System.currentTimeMillis())
			BgClassName = "oldshow_";
		else
			BgClassName = "show_";
		String category = SageApi.StringApi("GetShowCategory",
				new Object[] { sageAiring });
		if (category.equalsIgnoreCase("movie"))
			BgClassName = BgClassName + "movie";
		else if (category.equalsIgnoreCase("news"))
			BgClassName = BgClassName + "news";
		else if (category.equalsIgnoreCase("sports event")
				|| category.equalsIgnoreCase("sports non-event")
				|| category.equalsIgnoreCase("sports talk"))
			BgClassName = BgClassName + "sports";
		else
			BgClassName = BgClassName + "other";
		return BgClassName;
	}

	public void printIdArg(PrintWriter out) throws Exception {
		out.print(getIdArg());
	}

	public String getIdArg() throws Exception {
		String rv = null;
		if (idType == ID_TYPE_MEDIAFILE)
			rv = "MediaFileId=";
		else if (idType == ID_TYPE_AIRING)
			rv = "AiringId=";
		else
			return null;
		return rv + Integer.toString(id);

	}
}
