/*
 * Created on Oct 28, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package net.sf.sageplugins.webserver;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.lang.reflect.InvocationTargetException;
import java.net.URLDecoder;
import java.text.DateFormat;
import java.util.Date;
import java.util.Vector;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.servlet.ServletException;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import Acme.Serve.Serve;

import net.sf.sageplugins.sageutils.Translate;

/**
 * Core sage servlet with helper functions
 */
public abstract class SageServlet extends HttpServlet {



	public void log(String arg0) {
		if ( !arg0.equals("init") && !arg0.equals("destroy"))
			super.log(arg0);
	}
	static String[][] ENABLE_DISABLE_OPTS=new String[][]{{"true","Enabled"},{"false","Disabled"}};
	static String[][] FILTER_OPTS=new String[][]{
			{"##AsSageTV##","Same as SageTV"},
			{"##BLANK##","All"},
			{"IsFavorite|IsManualRecord","Manual Records & Favorites"},
			{"IsManualRecord","Manual Records"},
			{"IsFavorite","Favorites"},
	};
	
	static boolean init=false;
	static boolean hasUI=false;
	//	Vector of Object[2] menus
	// Where Object[0]=string title
	// and Object[1]=Vector of String[2] submenu name/item defs
	static Vector menuitems=null;
	static Date menuFileLastChanged;
	static File menufile=null;
	
	protected SageServlet(){
		if ( ! init) {
			init=true;
			Object widgets=null;
			try {
				widgets=SageApi.Api("GetAllWidgets");
				if ( SageApi.Size(widgets)>0)
					hasUI=true;
			}catch (Exception e) {}
			try {
				File menufile=new File(SageApi.GetProperty("nielm/webserver/root","webserver")+
						File.separator+
						"menu.properties");
				FileReader fr=new FileReader(menufile);
				BufferedReader br=new BufferedReader(fr);
				String line;
				Pattern pat=Pattern.compile("([^=]+)=(.+)");
				Pattern group=Pattern.compile("\\[([^]]+)\\]");
				menuitems=new Vector();//of Object[2];
				Vector currmenu=null; // String name,String items;
				while ( null!=(line=br.readLine())){
					line=line.trim();
					if ( ! line.startsWith("#")
						&& line.length()>0 ) { 
						if (currmenu!=null ) {
							Matcher patmatch=pat.matcher(line);
							if ( patmatch.matches() ){
								currmenu.add(new String[]{patmatch.group(1),patmatch.group(2)});
							}
						}
						Matcher groupmatch=group.matcher(line);
						if ( groupmatch.matches()) {
							currmenu=new Vector();
							menuitems.add(new Object[]{groupmatch.group(1),currmenu});
						}
					}
				}
				br.close();
				fr.close();
			} catch (Exception e){
				Serve.extLog("Error loading menu file:"+ e.toString());
				e.printStackTrace(System.out);
				// default menu
				menuitems=new Vector();
				Vector currmenu=new Vector();
				menuitems.add(new Object[]{"Sage TV",currmenu});
				currmenu.add(new String[]{"Home","Home"});
				currmenu.add(new String[]{"Sage Recordings","Recordings"});
				currmenu=new Vector();
				menuitems.add(new Object[]{"Schedule Recordings",currmenu});
				currmenu.add(new String[]{"Upcoming Recordings","RecordingSchedule"});
				currmenu.add(new String[]{"Timed Recording","TimedRecord"});
				currmenu.add(new String[]{"Recording Conflicts","Conflicts"});
				currmenu=new Vector();
				menuitems.add(new Object[]{"Program Guide",currmenu});
				currmenu.add(new String[]{"List view","EpgList"});
				currmenu.add(new String[]{"Grid view","EpgGrid"});
				currmenu.add(new String[]{"Search EPG","Search"});
			}
			
		}
			
	}
	
	protected void doGet(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		try {
			doServletGet(req,resp);
		} catch (Throwable e) {
			if (!resp.isCommitted()){
				resp.setStatus(HttpServletResponse.SC_INTERNAL_SERVER_ERROR);
				resp.setContentType("text/html");
			}
			PrintWriter out = resp.getWriter();
			out.println();
			out.println();
			out.println("<body><pre>");
			out.println("Exception while processing servlet:\r\n"+e.toString());
			e.printStackTrace(out);
			out.println("</pre>");
			out.close();
			log("Exception while processing servlet",e);
		}
	}
	

    protected void doPost(HttpServletRequest arg0, HttpServletResponse arg1)
            throws ServletException, IOException {
        doGet(arg0, arg1);
    }
    
	protected abstract void doServletGet(HttpServletRequest req, HttpServletResponse resp)
	throws Exception;
	
	protected void htmlHeaders(HttpServletResponse resp){
		resp.setContentType("text/html; charset=iso-8859-1");
	    resp.setBufferSize(8192);
	}
	protected void xmlHeaders(HttpServletResponse resp){
		resp.setContentType("text/xml; charset=iso-8859-1");
	    resp.setBufferSize(8192);
	}
	protected void noCacheHeaders(HttpServletResponse resp){
		resp.setHeader("Cache-Control","no-cache"); //HTTP 1.1
	    resp.setHeader("Pragma","no-cache"); //HTTP 1.0
	    resp.setDateHeader ("Expires", 0); //prevents caching at the proxy server
	}
	protected void xhtmlHeaders(PrintWriter out) throws IOException{
		out.println("<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">");
		out.println("<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\" dir=\"ltr\">");
	}
	protected void jsCssImport(PrintWriter out) throws IOException{
		out.println(" <link rel=\"stylesheet\"  type=\"text/css\" media=\"all\" href=\"sage_all.css\"/>");
		out.println(" <link rel=\"stylesheet\"  type=\"text/css\" media=\"print\" href=\"sage_print.css\"/>");
		out.println(" <link rel=\"Shortcut Icon\" href=\"/favicon.ico\" type=\"image/x-icon\">");
		out.println(" <script type=\"text/javascript\" src=\"sage.js\"></script>");
	}
	

	protected void printMenu(HttpServletRequest req, PrintWriter out) throws IOException {
		out.println("<!-- start menu bar -->");
		out.println("<!-- odd alignment to work around nasty IE annoyance-->");
		out.println("  <ul id=\"myMenu\">");
		for ( int i = 0 ; i < menuitems.size(); i ++){
			Object[] menu=(Object[])menuitems.get(i);
			String menuname=(String)menu[0];
			Vector submenu=(Vector)menu[1];
			
			if  (submenu.size()==1) {
				String[] menuitem=(String[])submenu.get(0);
				// 1 sub-item, show at top level
				out.println("<li>\r\n"
						   +"      <a href=\""+Translate.encode(menuitem[1])+"\">"+Translate.encode(menuname)+"</a></li>");
			} else {
				// multiple sub-items
				out.println("<li>\r\n"
						   +"    <a href=\"#\">"+Translate.encode(menuname)+"</a><ul>");
				for ( int j = 0 ; j < submenu.size(); j ++){
					String[] menuitem=(String[])submenu.get(j);
					out.print("      <li><a href=\""+Translate.encode(menuitem[1])+"\">"+Translate.encode(menuitem[0])+"</a></li>");
				}
				out.print("</ul></li>");
			}
		}
		out.println();
		out.println("  </ul>");
		out.println("<script type=\"text/javascript\">\r\n"+
					"//Browsercheck --\r\n"+
					"if(document.getElementById && document.createElement){\r\n"+
					"	setClasses(\"myMenu\");\r\n"+
					"	document.getElementById(\"myMenu\").style.position=\"absolute\";\r\n"+
					"}\r\n"+
					"</script>\r\n");
		out.println("<!-- end menu bar -->");
	}
	protected void printLastUpdated(HttpServletRequest req, PrintWriter out){
		out.println("Last updated: "+ DateFormat.getDateTimeInstance().format(new Date()));
		out.print("<a href=\""+req.getRequestURI());
		if ( req.getQueryString()!=null)
			out.print("?"+req.getQueryString());
		out.println("\">[Refresh]</a>");
	}
	protected void printTitle(PrintWriter out, String screenname) {
		out.println("<div id=\"title\">");
	    out.println("<h1><a href=\"Home\" title=\"home\"><img src=\"sagelogo.gif\" alt=\"SageTV logo\" title=\"Home Screen\" border=\"0\"/></a>"+screenname+"</h1>");
	    out.println("</div>");
	    
	}
	protected Object checkManualRecordConflicts(long startmillis, long stopmillis, Object channel)
	throws Exception{
		Object rv=null;
		
		Object inputs = SageApi.Api("GetConfiguredCaptureDeviceInputs");
		//for each input
		for (int inputnum=0;inputnum<SageApi.Size(inputs);inputnum++) {
			Object input=SageApi.GetElement(inputs,inputnum);
			Object lineup=SageApi.Api("GetLineupForCaptureDeviceInput",new Object[]{input});
			if ( SageApi.booleanApi("IsChannelViewableOnLineup",new Object[]{channel, lineup}) ){
				Object capdev=SageApi.Api("GetCaptureDeviceForInput",new Object[]{input});
				Object overlaps = SageApi.Api("GetScheduledRecordingsForDeviceForTime",new Object[]{
										capdev,new Long(startmillis),new Long(stopmillis)});
				overlaps = SageApi.Api("FilterByBoolMethod",new Object[]{overlaps,"IsManualRecord", Boolean.TRUE});
				if ( SageApi.Size(overlaps)==0)
					return null;
				rv=SageApi.Api("DataUnion",new Object[]{rv,overlaps});
			}
		}
		System.out.println("returning "+SageApi.Size(rv)+" overlaps");
		return rv;
	}
	
  public static String GetCookieValue(Cookie[] cookies,
  		String cookieName,
		String defaultValue) throws Exception {
  	for(int i=0; i<cookies.length; i++) {
  		Cookie cookie = cookies[i];
  		if (cookieName.equals(cookie.getName())){
  		  String value;
  		        value=URLDecoder.decode(cookie.getValue(),"ISO-8859-1");
  			if ( value.equals("##BLANK##"))
  				value="";
  			return(value);
  		}
  	}
  	return(defaultValue);
  }
	
	public String GetOption(HttpServletRequest req,String opt, String defarg)
	throws Exception {
		Cookie[] cookies=req.getCookies();
		return GetCookieValue(cookies,opt,defarg);
	}
	/***
	 * 
	 * @param req
	 * @param optionset
	 * @param optionname
	 * @param prop
	 * @param defarg -- default value (includes ##AsSageTV##)
	 * @param fallbackdef -- default value for GetProperties
	 * @return
	 */
	public String GetOptionOrProfile(HttpServletRequest req,
											String[][] optionset,
											String optionname, 
											String propertyname, 
											String defarg,
											String Sagedefarg)
	throws Exception {
		Cookie[] cookies=req.getCookies();
		Cookie cookie=null;
		for(int i=0; i<cookies.length; i++) {
	  		if (cookies[i].getName().equals(optionname)) {
	  			cookie=cookies[i];
	  			break;
	  		}
	  	}
		String value=null;
		if ( cookie != null) {
			value=URLDecoder.decode(cookie.getValue(),"ISO-8859-1");
			if ( value.equals("##AsSageTV##") )
				value=null;
		}

		if ( value == null && propertyname!=null){
			try {
				value=SageApi.GetProperty(propertyname,Sagedefarg);
				// translate "" -> ##BLANK## as cookies cannot be blank
				if ( value != null && value.length()==0)
					value="##BLANK##";
			} catch (InvocationTargetException e){}
		}

		if ( value != null) {
			// got a value -- verify it
			for ( int i=0; i<optionset.length;i++){
				if ( optionset[i][0].equals(value)) {
					if ( value.equals("##BLANK##"))
						return "";
					else
						return value;
				}
			}
			// if got to here, then invalid value found
			log("invalid value: '"+value+"' found for option: "+optionname+" using defaults");
			value=null;
		}
		
		// if got to here, no value or invalid value used
		if ( defarg.equals("##AsSageTV##") && Sagedefarg != null )
				return Sagedefarg;
			else
				return defarg;
	}
	
	public void PrintOptionsDropdown(HttpServletRequest req,PrintWriter out,String opt,String defval,String[][]options)
	throws Exception {
		PrintOptionsDropdown(req,out,opt,null,defval,options);
	}
	public void PrintOptionsDropdown(HttpServletRequest req,PrintWriter out,String opt, String prop, String defval, String[][]options)
	throws Exception {
		String currval=GetOption(req,opt,defval);
		out.println("  <select name='"+opt+"' onchange='SetCookie(\""+opt+"\",this.options[this.selectedIndex].value);window.location.reload(true);'>");
		printOptionsList(out,options,currval);
		out.println("  </select>");
	}
	public static void printOptionsList(PrintWriter out,String[][] options, String currval){
		if ( currval != null && currval.length()==0)
			currval="##BLANK##";
		
		for ( int i=0; i<options.length;i++){
			out.print("    <option value='"+options[i][0]+"'");
			if ( currval!=null && options[i][0].equals(currval))
				out.print(" selected=\"selected\"");
			out.println(">"+Translate.encode(options[i][1])+"</option>");
		}
	}
}
