package net.sf.sageplugins.webserver;

import java.io.PrintWriter;
import java.text.DateFormat;
import java.text.DecimalFormat;
import java.util.Date;
import java.util.Iterator;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author Owner
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class StatusXMLServlet extends SageServlet {

	protected void doServletGet(HttpServletRequest req, HttpServletResponse resp) throws Exception {
		// set headers before accessing the Writer
		xmlHeaders(resp);
		noCacheHeaders(resp);
		PrintWriter out = resp.getWriter();

		out.println("<Data>");

		Object captureDevInputs = SageApi.Api("GetConfiguredCaptureDeviceInputs", null);
		Map captureDevs = (Map) SageApi.Api("GroupByMethod", new Object[] { captureDevInputs,
				"GetCaptureDeviceForInput" });
		// captureDevs is a Map

		if (!captureDevs.isEmpty()) {
			out.println("\t<Recording>");
			for (Iterator i = captureDevs.keySet().iterator(); i.hasNext();) {
				Object capDev = i.next();
				Object recfile = SageApi.Api("GetCaptureDeviceCurrentRecordFile", new Object[] { capDev });
				if (recfile != null) {
					new Airing(recfile).printAiringXML(req, out);
				} 
			}
			out.println("\t</Recording>");
		}
		if (SageApi.booleanApi("AreThereUnresolvedConflicts", null)) {
			Object UnresolvedConflicts = SageApi.Api("GetAiringsThatWontBeRecorded", new Object[] { Boolean.TRUE });
			if (SageApi.Size(UnresolvedConflicts) > 0) {
				out.println("<Conflicts>" + Integer.toString(SageApi.Size(UnresolvedConflicts)) + "</Conflicts>");
			}
		}

		DecimalFormat fmt = new DecimalFormat("0.00");
		out.println("<DiskSpace>");

		double diskavail = ((Long) SageApi.Api("GetTotalDiskspaceAvailable", null)).doubleValue() / 1000000000.0;
		double diskused = ((Long) SageApi.Api("GetUsedVideoDiskspace", null)).doubleValue() / 1.0E9;

		int numpartials = 0;
		double partialsspace = 0.0;
		boolean partialsFree = SageApi.GetBooleanProperty("nielm/diskbar_partials_free", true);
		if (partialsFree) {
			Object mediafiles = SageApi.Api("GetMediaFiles");
			mediafiles = SageApi.Api("FilterByBoolMethod", new Object[] { mediafiles, "IsTVFile", Boolean.TRUE });
			mediafiles = SageApi.Api("FilterByBoolMethod", new Object[] { mediafiles, "IsLibraryFile", Boolean.FALSE });
			mediafiles = SageApi.Api("FilterByBoolMethod", new Object[] { mediafiles, "IsCompleteRecording",
					Boolean.FALSE });
			mediafiles = SageApi
					.Api("FilterByBoolMethod", new Object[] { mediafiles, "IsManualRecord", Boolean.FALSE });
			numpartials = SageApi.Size(mediafiles);
			for (int num = 0; num < numpartials; num++) {
				Object file = SageApi.GetElement(mediafiles, num);
				partialsspace += ((Long) SageApi.Api("GetSize", new Object[] { file })).doubleValue();
			}
			partialsspace /= 1.0E9;
		}
		int diskusedpc = new Double(100.0 * (diskused - partialsspace) / (diskavail + diskused)).intValue();

		int NumUpcommingRecs = 0;
		long lookahead = ((long) SageApi.GetIntProperty("nielm/diskbar_lookahead_hours", 48)) * 60 * 60 * 1000;
		long now = new Date().getTime();
		Object recordings = SageApi.Api("GetScheduledRecordings");
		recordings = SageApi.Api("FilterByRange", new Object[] { recordings, "GetAiringEndTime", new Long(now),
				new Long(now + lookahead), Boolean.TRUE });
		if (SageApi.GetBooleanProperty("nielm/diskbar_lookahead_only_requested", true)) {
			Object manrec = SageApi.Api("FilterByBoolMethod",
					new Object[] { recordings, "IsManualRecord", Boolean.TRUE });
			Object faverec = SageApi.Api("FilterByBoolMethod", new Object[] { recordings, "IsFavorite", Boolean.TRUE });
			recordings = SageApi.Api("DataUnion", new Object[] { manrec, faverec });
		}
		double bytesneeded = 0;
		for (int num = 0; num < SageApi.Size(recordings); num++) {
			Object sageAiring = SageApi.GetElement(recordings, num);
			Object quality = SageApi.Api("GetRecordingQuality", new Object[] { sageAiring });
			Long duration = (Long) SageApi.Api("GetScheduleDuration", new Object[] { sageAiring });
			if (SageApi.Size(quality) <= 0) quality = SageApi.Api("GetDefaultRecordingQuality");
			Long bitrate = (Long) SageApi.Api("GetRecordingQualityBitrate", new Object[] { quality });
			bytesneeded += (bitrate.doubleValue() / 8.0 * duration.doubleValue() / 1000.0);
		}
		double diskneeded = (bytesneeded / 1.0E9);
		int diskreqpc = new Double(100.0 * diskneeded / (diskavail + diskused)).intValue();

		out.println("\t<DiskUsedPC>" + Integer.toString(diskusedpc) + "</DiskUsedPC>");
		if ((diskusedpc + diskreqpc) > 100) {
			diskreqpc = 100 - diskusedpc;
		} 
		out.println("\t<DiskReqdPC>" + Integer.toString(diskusedpc) + "</DiskReqdPC>");
		out.println("\t<DiskAvail>" + fmt.format(diskavail) + "GB" + "</DiskAvail>");
		out.println("\t<DiskUsed>" + fmt.format(diskused) + "GB" + "</DiskUsed>");
		out.println("\t<UpcomingHours>" + Long.toString(lookahead / 3600000) + "</UpcomingHours>");
		out.println("\t<UpcomingRecs>" + Integer.toString(SageApi.Size(recordings)) + "</UpcomingRecs>");
		out.println("\t<UpcomingReq>" + fmt.format(diskneeded) + "GB</UpcomingReq>");
		out.println("\t<TotalVideo>" + 
				fmt.format(((Long) SageApi.Api("GetTotalVideoDuration", null)).doubleValue() / 3600000.0) + 
				"Hrs</TotalVideo>");
		out.println("\t</DiskSpace>");
		out.println("</Data>");
		out.close();

	}
}
